#include <stdio.h>
#include <stdlib.h>
#include "wish.h"

int tun_largo;
char *out;
int inter_x, inter_y;

struct nodo {
    struct nodo *next;
    int item;
};

struct queue {
    struct nodo *next;
    int cnt;
    int x, y;
} *t1, *t2;

#define GORDO 10

struct queue *InitQ(int x, int y) {
    struct queue *t;

    t=(struct queue *)malloc(sizeof(struct queue));
    t->x = x; t->y = y;
    t->cnt = 0;
    t->next = NULL;
    return t;
}

void AddQ(struct queue *q, int item) {
    struct nodo *p;

    p = (struct nodo *)malloc(sizeof(struct nodo));
    p->item = item;
    p->next = q->next;
    q->next = p;
    q->cnt++;
}

int XtractQ(struct queue *q) {
    struct nodo *p;
    int item;

    if(q->next == NULL) return -1;

    p = q->next;
    q->next = p->next;
    q->cnt--;

    item = p->item;
    free(p);
    return item;
}

move_t(char tunnel[]) {
    int i;

    if(tunnel[tun_largo] != 0)
	delete_w(tunnel[tun_largo]);
    for(i=tun_largo-1; i >= 0; i--) {
	if(tunnel[i] != 0) {
	    move_w(tunnel[i], GORDO, 0); 
            usleep(200000);
	    tunnel[i+1] = tunnel[i];
	    tunnel[i]=0;
	}
    }
    tunnel[0] = 0;
}

void xfer_t(struct queue *t, char out[]) {
    int item;

    if(t->cnt != 0 && out[0] == 0) {
	item = XtractQ(t);
        coords_w(item, inter_x, inter_y, GORDO);
        usleep(500000);
        out[0] = item;
    }
}


main(int argc, char *argv[]) {
    int i, alive;
    int itxt1=0, itxt2=0;
    char s1[128], s2[128];
    int tot_autos;
    int nautos = 0;

    if(argc!=3)
      {
        fprintf(stderr, "Use: %s nautos largo\n", argv[0]);
        exit(1);
      }

    tot_autos=atoi(argv[1]);
    tun_largo=atoi(argv[2]);

    t1 = InitQ(GORDO, 2*GORDO);
    t2 = InitQ(GORDO, 4*GORDO);

    out=(char *)malloc(tun_largo+1);
    inter_x = 3*GORDO;
    inter_y = 3*GORDO;

    init_w((tun_largo+1)*GORDO+6*GORDO, 6*GORDO);

    create_obj_w(inter_x, inter_y, GORDO, "rectangle", "white");

    for(i=0; i <= tun_largo; i++) 
	out[i]=0;

   sleep(1); 

    while(nautos < tot_autos) {
        /* si usan 120 en vez de 64 pueden ver lo unfair que es!*/
	if((rand()>>24) < 64) {
	    AddQ(t1, create_obj_w(t1->x, t1->y, GORDO, "oval", "red"));
	    nautos++;
        }
	if((rand()>>24) < 64) {
	    AddQ(t2, create_obj_w(t2->x, t2->y, GORDO, "oval", "green"));
	    nautos++;
	}

    	xfer_t(t1, out);
	xfer_t(t2, out);

	move_t(out);
	
        sprintf(s1, "cnt=%d", t1->cnt);
        sprintf(s2, "cnt=%d", t2->cnt);
    	if(itxt1 != 0) delete_w(itxt1);
    	if(itxt2 != 0) delete_w(itxt2);
        itxt1 = create_obj_w(t1->x+2*GORDO, t1->y-GORDO, GORDO, "text", s1);
        itxt2 = create_obj_w(t2->x+2*GORDO, t2->y+GORDO+5, GORDO, "text", s2);
    }

    close_w("Finish!", 2*GORDO, GORDO);
}
